﻿
Imports System.Collections

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Text = AppTitleAndVersion()
        Load_INI()
        Joy_Open()
        TextBox1.Text = JoyGetName()
        Timer1.Interval = 10
        Timer1.Start()
        Show()
        InitImages()
        ClearStick1()
        ClearStick2()
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' ===================================================================================
    '   MenuStrip Gradient - Vertical
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(160, 160, 160), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub

    ' ===========================================================================================================
    '   Menu Commands
    ' ===========================================================================================================
    Private Sub Menu_ReloadDevice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_ReloadDevice.Click
        Joy_Open()
        TextBox1.Text = JoyGetName()
        ClearStick1()
        ClearStick2()
    End Sub

    Friend GamePadType As Int32 = 1
    Private Sub Menu_GamepadType_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_GamepadType.DropDownOpening
        ' ------------------------------------------------------------------------ with IndexOf
        For Each item As ToolStripMenuItem In Menu_GamepadType.DropDownItems
            If Menu_GamepadType.DropDownItems.IndexOf(item) + 1 = GamePadType Then
                item.Checked = True
            Else
                item.Checked = False
            End If
        Next
    End Sub
    Private Sub Menu_GamepadType1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_GamepadType1.Click
        GamePadType = 1
    End Sub
    Private Sub Menu_GamepadType2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_GamepadType2.Click
        GamePadType = 2
    End Sub
    Private Sub Menu_GamepadType3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_GamepadType3.Click
        GamePadType = 3
    End Sub

    Private Sub Menu_ControlPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_ControlPanel.Click
        Joy_OpenControlPanel()
    End Sub

    Private Sub Menu_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_SaveImage.Click
        SaveImage_("Theremino_GamepadTester_" + TextBox1.Text, Me)
    End Sub

    Private Sub Menu_Clear1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Clear1.Click
        ClearStick1()
    End Sub

    Private Sub Menu_Clear2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Clear2.Click
        ClearStick2()
    End Sub

    ' ===========================================================================================================
    '   Execution
    ' ===========================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not JoyReadState() Then Return
        TextBox2.Text = ReadJoystickString()
        Joy_ShowStickPositions(PictureBox1, PictureBox2)
        Joy_TestDeadZones()
    End Sub

    Friend Sub InitImages()
        InitPictureboxImage(PictureBox1)
        InitPictureboxImage(PictureBox2)
    End Sub

    Friend Sub ClearStick1()
        Graphics.FromImage(PictureBox1.Image).Clear(PictureBox1.BackColor)
        PictureBox1.Invalidate()
        Joy_ClearDeadZones1()
    End Sub

    Friend Sub ClearStick2()
        Graphics.FromImage(PictureBox2.Image).Clear(PictureBox2.BackColor)
        PictureBox2.Invalidate()
        Joy_ClearDeadZones2()
    End Sub

    Friend Sub InitPictureboxImage(ByVal pbox As PictureBox)
        With pbox
            If .ClientSize.Height < 1 Then Return
            If .Image Is Nothing OrElse .Image.Width <> .ClientSize.Width _
                                 OrElse .Image.Height <> .ClientSize.Height Then
                .Image = New Bitmap(.ClientRectangle.Width, _
                                    .ClientRectangle.Height, _
                                    Imaging.PixelFormat.Format24bppRgb)
            End If
        End With
    End Sub

End Class
