﻿Imports Microsoft.DirectX.DirectInput

' DirectX DLLs are to be added from GAC 2902 with SpecificVersion=True and CopyLocal=True
' Project/References/Add/Browse/
' C:\WINDOWS\assembly\GAC\Microsoft.DirectX\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.dll
' C:\WINDOWS\assembly\GAC\Microsoft.DirectX.DirectInput\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.DirectInput.dll

Module Module_Joystick

    ' Control	                    DirectInput HID Mapping
    ' ------------------------------------------------------
    ' Left Stick	                X, Y
    ' Right Stick	                Rx, Rz
    ' Left Trigger + Right Trigger	Rx
    ' D-Pad Up, Down, Left, Right	Hat Switch
    ' A	                            Button1
    ' B	                            Button 2
    ' X	                            Button 3
    ' Y	                            Button 4
    ' LB (left bumper)	            Button 5
    ' RB (right bumper)	            Button 6
    ' BACK	                        Button 7
    ' START	                        Button 8
    ' LSB (left stick button)	    Button 9
    ' RSB (right stick button)	    Button 10

    ' -------------------------------------------------------
    Private DeadZone1 As Single
    Private DeadZone2 As Single
    Private DeadZone3 As Single
    Private DeadZone4 As Single

    Private DEV As Device
    Private JoyState As JoystickState

    Friend Sub Joy_Open()
        Dim gameControllerList As DeviceList
        gameControllerList = Manager.GetDevices(DeviceClass.GameControl, _
                                                EnumDevicesFlags.AttachedOnly)
        If gameControllerList.Count > 0 Then
            For Each devInstance As DeviceInstance In gameControllerList
                DEV = New Device(devInstance.InstanceGuid)
                'SetProps()
                'DEV.Properties.AxisModeAbsolute = True
                'DEV.Properties.SetRange(ParameterHow.ByDevice, 0, New InputRange(0, 65534))
                DEV.Properties.SetSaturation(ParameterHow.ByDevice, 0, 10000)
                DEV.Properties.SetDeadZone(ParameterHow.ByDevice, 0, 0)
                DEV.SetCooperativeLevel(Form1, _
                                        CooperativeLevelFlags.Exclusive Or _
                                        CooperativeLevelFlags.Background)
                DEV.SetDataFormat(DeviceDataFormat.Joystick)
                DEV.Acquire()
                Exit For
            Next
        End If
    End Sub

    'Private Sub SetProps()
    '    ' -----------------------------------------------------------------------
    '    '  BY DEVICE
    '    ' -----------------------------------------------------------------------
    '    'DEV.Properties.SetRange(ParameterHow.ByDevice, 0, New InputRange(RangeMin, RangeMax))
    '    'DEV.Properties.SetSaturation(ParameterHow.ByDevice, 0, 10000)
    '    'DEV.Properties.SetDeadZone(ParameterHow.ByDevice, 0, 1000)
    '    ' -----------------------------------------------------------------------
    '    '  BY OFFSET
    '    ' -----------------------------------------------------------------------
    '    'DEV.Properties.SetDeadZone(ParameterHow.ByOffset, JoystickOffset.X, 10000)
    '    'DEV.Properties.SetDeadZone(ParameterHow.ByOffset, JoystickOffset.Y, 1000)
    '    ' -----------------------------------------------------------------------
    '    '  BY ID
    '    ' -----------------------------------------------------------------------
    '    For Each DOI As DeviceObjectInstance In DEV.Objects
    '        If (DOI.ObjectId And CInt(DeviceObjectTypeFlags.Axis)) <> 0 Then
    '            ' -----------------------------------------------------
    '            'Dim ir As InputRange = DEV.Properties.GetPhysicalRange(ParameterHow.ById, DOI.ObjectId)
    '            'Dim g As Int32 = DEV.Properties.GetGranularity(ParameterHow.ById, DOI.ObjectId)
    '            ' -----------------------------------------------------
    '            'DEV.Properties.SetRange(ParameterHow.ById, DOI.ObjectId, New InputRange(0, 65535))
    '            'DEV.Properties.SetDeadZone(ParameterHow.ById, DOI.ObjectId, 1)
    '            'DEV.Properties.SetSaturation(ParameterHow.ById, DOI.ObjectId, 10000)
    '            ' -----------------------------------------------------
    '            'Dim values(1) As CalibrationPoint
    '            'values(0).RawData = 31768
    '            'values(0).ScalingValue = 32758
    '            'values(0).RawData = 33768
    '            'values(0).ScalingValue = 32778
    '            'DEV.Properties.SetCalibrationPoints(ParameterHow.ById, DOI.ObjectId, values)
    '        End If
    '    Next
    'End Sub

    Friend Sub JoyClose()
        If DEV Is Nothing Then Return
        DEV.Unacquire()
        DEV = Nothing
    End Sub

    Friend Function JoyReadState() As Boolean
        If DEV Is Nothing Then Return False
        Try
            JoyState = DEV.CurrentJoystickState
            JoyStateToStickvalues()
            Return True
        Catch
            JoyClose()
            Return False
        End Try
    End Function

    Friend Sub Joy_OpenControlPanel()
        If DEV Is Nothing Then Return
        DEV.RunControlPanel()
    End Sub

    Friend Function JoyGetName() As String
        If DEV Is Nothing Then Return "No device connected"
        Return DEV.Properties.ProductName.Trim
        'Return DEV.DeviceInformation.ProductName.Trim
        'Return DEV.DeviceInformation.InstanceName.Trim
    End Function

    Friend Sub JoyVibrate()
        If DEV Is Nothing Then Return
        'Dim b(1) As Byte
        'DEV.SendHardwareCommand(1, b)
        'DEV.Properties.ForceFeedbackGain = 10000
        'DEV.SendForceFeedbackCommand(ForceFeedbackCommand.SetActuatorsOn)
        'Threading.Thread.Sleep(500)
        'DEV.SendForceFeedbackCommand(ForceFeedbackCommand.SetActuatorsOff)
    End Sub

    Friend Function ReadJoystickString() As String
        ' -------------------------------------------------
        Dim s As String = ""
        Dim i() As Int32
        Dim b() As Byte
        ' -------------------------------------------------
        b = JoyState.GetButtons()
        s += "Buttons: "
        For n As Int32 = 0 To 15
            If b(n) > 0 Then
                s += (n + 1).ToString + " "
            Else
                s += "  "
            End If
        Next
        s += vbCrLf
        ' -------------------------------------------------
        s += "X: " + JoyState.X.ToString + vbCrLf
        s += "Y: " + JoyState.Y.ToString + vbCrLf
        s += "Z: " + JoyState.Z.ToString + vbCrLf
        s += "RZ: " + JoyState.Rz.ToString + vbCrLf
        ' -------------------------------------------------
        s += "RX: " + JoyState.Rx.ToString + vbCrLf
        s += "RY: " + JoyState.Ry.ToString + vbCrLf
        ' -------------------------------------------------
        i = JoyState.GetPointOfView
        s += "PointOfView (0): " + i(0).ToString + vbCrLf
        s += "PointOfView (1): " + i(1).ToString + vbCrLf
        ' -------------------------------------------------
        's += vbCrLf
        '' -------------------------------------------------
        'i = JoyState.GetSlider
        's += "Slider  (0): " + i(0).ToString + vbCrLf
        's += "Slider  (1): " + i(1).ToString + vbCrLf
        '' -------------------------------------------------
        'i = JoyState.GetASlider
        's += "ASlider (0): " + i(0).ToString + vbCrLf
        's += "ASlider (1): " + i(1).ToString + vbCrLf
        '' -------------------------------------------------
        'i = JoyState.GetVSlider
        's += "VSlider (0): " + i(0).ToString + vbCrLf
        's += "VSlider (1): " + i(1).ToString + vbCrLf
        '' -------------------------------------------------
        'i = JoyState.GetFSlider
        's += "FSlider (0): " + i(0).ToString + vbCrLf
        's += "FSlider (1): " + i(1).ToString + vbCrLf
        '' -------------------------------------------------
        's += vbCrLf
        '' -------------------------------------------------
        's += "AX: " + JoyState.AX.ToString + vbCrLf
        's += "AY: " + JoyState.AY.ToString + vbCrLf
        's += "AZ: " + JoyState.AZ.ToString + vbCrLf
        '' -------------------------------------------------
        's += "ARX: " + JoyState.ARx.ToString + vbCrLf
        's += "ARY: " + JoyState.ARy.ToString + vbCrLf
        's += "ARZ: " + JoyState.ARz.ToString + vbCrLf
        '' -------------------------------------------------
        's += "FX: " + JoyState.FX.ToString + vbCrLf
        's += "FY: " + JoyState.FY.ToString + vbCrLf
        's += "FZ: " + JoyState.FZ.ToString + vbCrLf
        '' -------------------------------------------------
        's += "FRX: " + JoyState.FRx.ToString + vbCrLf
        's += "FRY: " + JoyState.FRy.ToString + vbCrLf
        's += "FRZ: " + JoyState.FRz.ToString + vbCrLf
        '' -------------------------------------------------
        's += "VX: " + JoyState.VX.ToString + vbCrLf
        's += "VY: " + JoyState.VY.ToString + vbCrLf
        's += "VZ: " + JoyState.VZ.ToString + vbCrLf
        '' -------------------------------------------------
        's += "VRX: " + JoyState.VRx.ToString + vbCrLf
        's += "VRY: " + JoyState.VRy.ToString + vbCrLf
        's += "VRZ: " + JoyState.VRz.ToString + vbCrLf
        Return s
    End Function

    Private StickLeftH As Single
    Private StickLeftV As Single
    Private StickRightH As Single
    Private StickRightV As Single
    Private Sub JoyStateToStickvalues()
        Select Case Form1.GamePadType
            Case 1   ' Normal
                StickLeftH = JoyState.X
                StickLeftV = JoyState.Y
                StickRightH = JoyState.Z
                StickRightV = JoyState.Rz
            Case 2   ' Saitek P2900 (Right stick: HV exchanged)
                StickLeftH = JoyState.X
                StickLeftV = JoyState.Y
                StickRightH = JoyState.Rz
                StickRightV = JoyState.Z
            Case 3   ' Atomic PC (Left stick: H inverted - Right stick: HV ex. + V inverted)
                StickLeftH = 65535 - JoyState.X
                StickLeftV = JoyState.Y
                StickRightH = JoyState.Rz
                StickRightV = 65535 - JoyState.Z
        End Select
    End Sub

    Friend Sub Joy_ClearDeadZones1()
        DeadZone1 = 32768
        DeadZone2 = 32768
    End Sub

    Friend Sub Joy_ClearDeadZones2()
        DeadZone3 = 32768
        DeadZone4 = 32768
    End Sub

    Friend Sub Joy_TestDeadZones()
        CalcDeadZone(StickLeftH, StickLeftV, DeadZone1)
        CalcDeadZone(StickLeftV, StickLeftH, DeadZone2)
        CalcDeadZone(StickRightH, StickRightV, DeadZone3)
        CalcDeadZone(StickRightV, StickRightH, DeadZone4)
        Form1.TextBox3.Text = " Dead zones :" + _
                                (DeadZone1 / 32768).ToString("  0.#%", ci) + _
                                (DeadZone2 / 32768).ToString("  0.#%", ci)
        Form1.TextBox4.Text = " Dead zones :" + _
                                (DeadZone3 / 32768).ToString("  0.#%", ci) + _
                                (DeadZone4 / 32768).ToString("  0.#%", ci)
    End Sub

    Private Sub CalcDeadZone(ByVal v1 As Single, ByVal v2 As Single, ByRef dzone As Single)
        v1 = Math.Abs(v1 - 32767)
        v2 = Math.Abs(v2 - 32767)
        If v1 > 100 And v2 > 100 Then
            If v1 < dzone Then dzone += (v1 - dzone) * 0.2F
        End If
        If dzone > 32740 Then dzone = 32740
    End Sub

    Dim x, y As Single
    Dim oldx1 As Single = -1
    Dim oldy1 As Single = -1
    Dim oldx2 As Single = -1
    Dim oldy2 As Single = -1
    Dim p As Pen = New Pen(Color.FromArgb(60, 60, 60), 3)
    Friend Sub Joy_ShowStickPositions(ByVal pic1 As PictureBox, ByVal pic2 As PictureBox)
        ShowStickPosition(pic1, StickLeftH, StickLeftV, oldx1, oldy1)
        ShowStickPosition(pic2, StickRightH, StickRightV, oldx2, oldy2)
    End Sub

    Private Sub ShowStickPosition(ByVal pic As PictureBox, _
                                  ByVal x As Single, ByVal y As Single, _
                                  ByRef ox As Single, ByRef oy As Single)
        x *= pic.Image.Width / 65536.0F
        y *= pic.Image.Height / 65536.0F
        If ox >= 0 Then
            Graphics.FromImage(pic.Image).DrawLine(p, ox, oy, x, y)
        End If
        ox = x
        oy = y
        pic.Invalidate()
    End Sub

End Module
